blob: 186a1513ee14f66ec34bbbb890b119737f6f2eb0 [file] [log] [blame]
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +01001#!/bin/bash
2#
3# Runner for an individual run-test.
4
5msg() {
6 if [ "$QUIET" = "n" ]; then
7 echo "$@"
8 fi
9}
10
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000011ANDROID_ROOT="/system"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010012ARCHITECTURES_32="(arm|x86|mips|none)"
Andreas Gampe1a5c4062015-01-15 12:10:47 -080013ARCHITECTURES_64="(arm64|x86_64|mips64|none)"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010014ARCHITECTURES_PATTERN="${ARCHITECTURES_32}"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000015BOOT_IMAGE=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010016COMPILE_FLAGS=""
17DALVIKVM="dalvikvm32"
18DEBUGGER="n"
19DEV_MODE="n"
20DEX2OAT=""
Alex Light8a0e0332015-10-26 10:11:58 -070021EXPERIMENTAL=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010022FALSE_BIN="/system/bin/false"
23FLAGS=""
Alex Light7233c7e2016-07-28 10:07:45 -070024ANDROID_FLAGS=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010025GDB=""
Nicolas Geoffraybaf91022014-10-08 09:56:45 +010026GDB_ARGS=""
27GDB_SERVER="gdbserver"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010028HAVE_IMAGE="y"
29HOST="n"
30INTERPRETER="n"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -080031JIT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010032INVOKE_WITH=""
Alex Lighte06b6342017-01-05 14:37:21 -080033IS_JVMTI_TEST="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010034ISA=x86
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000035LIBRARY_DIRECTORY="lib"
Colin Crossafd3c9e2016-09-16 13:47:21 -070036TEST_DIRECTORY="nativetest"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +000037MAIN=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010038OPTIMIZE="y"
39PATCHOAT=""
40PREBUILD="y"
41QUIET="n"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +000042RELOCATE="n"
Richard Uhler76f5cb62016-04-04 13:30:16 -070043STRIP_DEX="n"
Jeff Hao207a37d2014-10-29 17:24:25 -070044SECONDARY_DEX=""
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -070045TIME_OUT="gdb" # "n" (disabled), "timeout" (use timeout), "gdb" (use gdb)
46# Value in seconds
Hiroshi Yamauchifd3161a2017-01-18 14:47:25 -080047if [ "$ART_USE_READ_BARRIER" != "false" ]; then
Hiroshi Yamauchia9b296c2016-10-07 17:07:03 -070048 TIME_OUT_VALUE=2400 # 40 minutes.
Hiroshi Yamauchidcf0d4b2015-09-09 18:59:42 -070049else
Mathieu Chartier2576be22016-05-24 10:24:53 -070050 TIME_OUT_VALUE=1200 # 20 minutes.
Hiroshi Yamauchidcf0d4b2015-09-09 18:59:42 -070051fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010052USE_GDB="n"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +010053USE_JVM="n"
Igor Murashkin7617abd2015-07-10 18:27:47 -070054VERIFY="y" # y=yes,n=no,s=softfail
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010055ZYGOTE=""
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -070056DEX_VERIFY=""
Andreas Gampe65357032015-02-19 15:10:24 -080057USE_DEX2OAT_AND_PATCHOAT="y"
Andreas Gampe4d2ef332015-08-05 09:24:45 -070058INSTRUCTION_SET_FEATURES=""
Mathieu Chartier031768a2015-08-27 10:25:02 -070059ARGS=""
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -070060EXTERNAL_LOG_TAGS="n" # if y respect externally set ANDROID_LOG_TAGS.
61DRY_RUN="n" # if y prepare to run the test but don't run it.
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +000062TEST_VDEX="n"
Alex Lighte06b6342017-01-05 14:37:21 -080063TEST_IS_NDEBUG="n"
Calin Juravle857f0582016-12-20 14:36:59 +000064APP_IMAGE="y"
Nicolas Geoffray74981052017-01-16 17:54:09 +000065VDEX_FILTER=""
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010066
67while true; do
68 if [ "x$1" = "x--quiet" ]; then
69 QUIET="y"
70 shift
Alex Lighte06b6342017-01-05 14:37:21 -080071 elif [ "x$1" = "x--jvmti" ]; then
72 IS_JVMTI_TEST="y"
73 shift
Alex Lightfaf90b62016-08-12 14:43:48 -070074 elif [ "x$1" = "x-O" ]; then
Alex Lighte06b6342017-01-05 14:37:21 -080075 TEST_IS_NDEBUG="y"
Alex Lightfaf90b62016-08-12 14:43:48 -070076 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010077 elif [ "x$1" = "x--lib" ]; then
78 shift
79 if [ "x$1" = "x" ]; then
80 echo "$0 missing argument to --lib" 1>&2
81 exit 1
82 fi
83 LIB="$1"
84 shift
Alex Light97acf192016-03-17 09:59:38 -070085 elif [ "x$1" = "x--gc-stress" ]; then
86 # Give an extra 5 mins if we are gc-stress.
87 TIME_OUT_VALUE=$((${TIME_OUT_VALUE} + 300))
88 shift
Mathieu Chartier031768a2015-08-27 10:25:02 -070089 elif [ "x$1" = "x--testlib" ]; then
90 shift
91 if [ "x$1" = "x" ]; then
92 echo "$0 missing argument to --testlib" 1>&2
93 exit 1
94 fi
Mathieu Chartierde286fd2015-09-03 18:10:29 -070095 ARGS="${ARGS} $1"
Mathieu Chartier031768a2015-08-27 10:25:02 -070096 shift
David Srbecky52886112016-01-22 13:56:47 +000097 elif [ "x$1" = "x--args" ]; then
98 shift
99 if [ "x$1" = "x" ]; then
100 echo "$0 missing argument to --args" 1>&2
101 exit 1
102 fi
103 ARGS="${ARGS} $1"
104 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100105 elif [ "x$1" = "x-Xcompiler-option" ]; then
106 shift
107 option="$1"
108 FLAGS="${FLAGS} -Xcompiler-option $option"
109 COMPILE_FLAGS="${COMPILE_FLAGS} $option"
110 shift
Alex Light7233c7e2016-07-28 10:07:45 -0700111 elif [ "x$1" = "x--android-runtime-option" ]; then
112 shift
113 option="$1"
114 ANDROID_FLAGS="${ANDROID_FLAGS} $option"
115 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100116 elif [ "x$1" = "x--runtime-option" ]; then
117 shift
118 option="$1"
119 FLAGS="${FLAGS} $option"
120 shift
121 elif [ "x$1" = "x--boot" ]; then
122 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000123 BOOT_IMAGE="$1"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100124 shift
125 elif [ "x$1" = "x--no-dex2oat" ]; then
126 DEX2OAT="-Xcompiler:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800127 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100128 shift
129 elif [ "x$1" = "x--no-patchoat" ]; then
130 PATCHOAT="-Xpatchoat:${FALSE_BIN}"
Andreas Gampe65357032015-02-19 15:10:24 -0800131 USE_DEX2OAT_AND_PATCHOAT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100132 shift
133 elif [ "x$1" = "x--relocate" ]; then
134 RELOCATE="y"
135 shift
136 elif [ "x$1" = "x--no-relocate" ]; then
137 RELOCATE="n"
138 shift
139 elif [ "x$1" = "x--prebuild" ]; then
140 PREBUILD="y"
141 shift
Calin Juravle857f0582016-12-20 14:36:59 +0000142 elif [ "x$1" = "x--no-app-image" ]; then
143 APP_IMAGE="n"
144 shift
Richard Uhler76f5cb62016-04-04 13:30:16 -0700145 elif [ "x$1" = "x--strip-dex" ]; then
146 STRIP_DEX="y"
147 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100148 elif [ "x$1" = "x--host" ]; then
149 HOST="y"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000150 ANDROID_ROOT="$ANDROID_HOST_OUT"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100151 shift
152 elif [ "x$1" = "x--no-prebuild" ]; then
153 PREBUILD="n"
154 shift
155 elif [ "x$1" = "x--no-image" ]; then
156 HAVE_IMAGE="n"
157 shift
Jeff Hao207a37d2014-10-29 17:24:25 -0700158 elif [ "x$1" = "x--secondary" ]; then
159 SECONDARY_DEX=":$DEX_LOCATION/$TEST_NAME-ex.jar"
Calin Juravle175dc732015-08-25 15:42:32 +0100160 # Enable cfg-append to make sure we get the dump for both dex files.
161 # (otherwise the runtime compilation of the secondary dex will overwrite
Roland Levillainb0103ca2016-11-01 14:48:47 +0000162 # the dump of the first one).
Calin Juravle175dc732015-08-25 15:42:32 +0100163 FLAGS="${FLAGS} -Xcompiler-option --dump-cfg-append"
164 COMPILE_FLAGS="${COMPILE_FLAGS} --dump-cfg-append"
Jeff Hao207a37d2014-10-29 17:24:25 -0700165 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100166 elif [ "x$1" = "x--debug" ]; then
167 DEBUGGER="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800168 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100169 shift
170 elif [ "x$1" = "x--gdb" ]; then
171 USE_GDB="y"
172 DEV_MODE="y"
Brian Carlstrom93d6ce52014-11-04 22:31:35 -0800173 TIME_OUT="n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100174 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700175 elif [ "x$1" = "x--gdb-arg" ]; then
176 shift
177 gdb_arg="$1"
178 GDB_ARGS="${GDB_ARGS} $gdb_arg"
179 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100180 elif [ "x$1" = "x--zygote" ]; then
181 ZYGOTE="-Xzygote"
182 msg "Spawning from zygote"
183 shift
184 elif [ "x$1" = "x--dev" ]; then
185 DEV_MODE="y"
186 shift
187 elif [ "x$1" = "x--interpreter" ]; then
188 INTERPRETER="y"
189 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800190 elif [ "x$1" = "x--jit" ]; then
191 JIT="y"
192 shift
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100193 elif [ "x$1" = "x--jvm" ]; then
194 USE_JVM="y"
195 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100196 elif [ "x$1" = "x--invoke-with" ]; then
197 shift
198 if [ "x$1" = "x" ]; then
199 echo "$0 missing argument to --invoke-with" 1>&2
200 exit 1
201 fi
202 if [ "x$INVOKE_WITH" = "x" ]; then
203 INVOKE_WITH="$1"
204 else
205 INVOKE_WITH="$INVOKE_WITH $1"
206 fi
207 shift
208 elif [ "x$1" = "x--no-verify" ]; then
209 VERIFY="n"
210 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700211 elif [ "x$1" = "x--verify-soft-fail" ]; then
212 VERIFY="s"
213 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100214 elif [ "x$1" = "x--no-optimize" ]; then
215 OPTIMIZE="n"
216 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000217 elif [ "x$1" = "x--android-root" ]; then
218 shift
219 ANDROID_ROOT="$1"
220 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700221 elif [ "x$1" = "x--instruction-set-features" ]; then
222 shift
223 INSTRUCTION_SET_FEATURES="$1"
224 shift
Mathieu Chartier2576be22016-05-24 10:24:53 -0700225 elif [ "x$1" = "x--timeout" ]; then
226 shift
227 TIME_OUT_VALUE="$1"
228 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100229 elif [ "x$1" = "x--" ]; then
230 shift
231 break
232 elif [ "x$1" = "x--64" ]; then
233 ISA="x86_64"
234 GDB_SERVER="gdbserver64"
235 DALVIKVM="dalvikvm64"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000236 LIBRARY_DIRECTORY="lib64"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700237 TEST_DIRECTORY="nativetest64"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100238 ARCHITECTURES_PATTERN="${ARCHITECTURES_64}"
239 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700240 elif [ "x$1" = "x--pic-test" ]; then
241 FLAGS="${FLAGS} -Xcompiler-option --compile-pic"
242 COMPILE_FLAGS="${COMPILE_FLAGS} --compile-pic"
243 shift
Alex Light8a0e0332015-10-26 10:11:58 -0700244 elif [ "x$1" = "x--experimental" ]; then
245 if [ "$#" -lt 2 ]; then
246 echo "missing --experimental option" 1>&2
247 exit 1
248 fi
249 EXPERIMENTAL="$EXPERIMENTAL $2"
250 shift 2
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700251 elif [ "x$1" = "x--external-log-tags" ]; then
252 EXTERNAL_LOG_TAGS="y"
253 shift
254 elif [ "x$1" = "x--dry-run" ]; then
255 DRY_RUN="y"
256 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000257 elif [ "x$1" = "x--vdex" ]; then
258 TEST_VDEX="y"
259 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000260 elif [ "x$1" = "x--vdex-filter" ]; then
261 shift
262 option="$1"
263 VDEX_FILTER="--compiler-filter=$option"
264 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100265 elif expr "x$1" : "x--" >/dev/null 2>&1; then
266 echo "unknown $0 option: $1" 1>&2
267 exit 1
268 else
269 break
270 fi
271done
272
Alex Light8a0e0332015-10-26 10:11:58 -0700273if [ "$USE_JVM" = "n" ]; then
Alex Light7233c7e2016-07-28 10:07:45 -0700274 FLAGS="${FLAGS} ${ANDROID_FLAGS}"
Alex Light8a0e0332015-10-26 10:11:58 -0700275 for feature in ${EXPERIMENTAL}; do
Alex Lightfa022852015-10-28 09:13:20 -0700276 FLAGS="${FLAGS} -Xexperimental:${feature} -Xcompiler-option --runtime-arg -Xcompiler-option -Xexperimental:${feature}"
Alex Light8a0e0332015-10-26 10:11:58 -0700277 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xexperimental:${feature}"
278 done
279fi
280
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100281if [ "x$1" = "x" ] ; then
282 MAIN="Main"
283else
284 MAIN="$1"
Andreas Gampef2fdc732014-06-11 08:20:47 -0700285 shift
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100286fi
287
288if [ "$ZYGOTE" = "" ]; then
289 if [ "$OPTIMIZE" = "y" ]; then
290 if [ "$VERIFY" = "y" ]; then
291 DEX_OPTIMIZE="-Xdexopt:verified"
292 else
293 DEX_OPTIMIZE="-Xdexopt:all"
294 fi
295 msg "Performing optimizations"
296 else
297 DEX_OPTIMIZE="-Xdexopt:none"
298 msg "Skipping optimizations"
299 fi
300
301 if [ "$VERIFY" = "y" ]; then
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100302 JVM_VERIFY_ARG="-Xverify:all"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100303 msg "Performing verification"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700304 elif [ "$VERIFY" = "s" ]; then
305 JVM_VERIFY_ARG="Xverify:all"
306 DEX_VERIFY="-Xverify:softfail"
307 msg "Forcing verification to be soft fail"
308 else # VERIFY = "n"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100309 DEX_VERIFY="-Xverify:none"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100310 JVM_VERIFY_ARG="-Xverify:none"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100311 msg "Skipping verification"
312 fi
313fi
314
315msg "------------------------------"
316
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100317if [ "$DEBUGGER" = "y" ]; then
318 # Use this instead for ddms and connect by running 'ddms':
319 # DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_android_adb,server=y,suspend=y"
320 # TODO: add a separate --ddms option?
321
322 PORT=12345
323 msg "Waiting for jdb to connect:"
324 if [ "$HOST" = "n" ]; then
325 msg " adb forward tcp:$PORT tcp:$PORT"
326 fi
327 msg " jdb -attach localhost:$PORT"
328 DEBUGGER_OPTS="-agentlib:jdwp=transport=dt_socket,address=$PORT,server=y,suspend=y"
329fi
330
Alex Lightfba89fe2017-01-12 16:11:02 -0800331if [ "$IS_JVMTI_TEST" = "y" ]; then
332 plugin=libopenjdkjvmtid.so
333 agent=libtiagentd.so
334 lib=tiagentd
335 if [[ "$TEST_IS_NDEBUG" = "y" ]]; then
336 agent=libtiagent.so
337 plugin=libopenjdkjvmti.so
338 lib=tiagent
339 fi
340
341 ARGS="${ARGS} ${lib}"
342 if [[ "$USE_JVM" = "y" ]]; then
343 FLAGS="${FLAGS} -agentpath:${ANDROID_HOST_OUT}/nativetest64/${agent}=${TEST_NAME},jvm"
344 else
345 FLAGS="${FLAGS} -agentpath:${agent}=${TEST_NAME},art"
346 FLAGS="${FLAGS} -Xplugin:${plugin}"
Nicolas Geoffraya0619e22016-12-20 13:57:43 +0000347 FLAGS="${FLAGS} -Xcompiler-option --debuggable"
Alex Lightfba89fe2017-01-12 16:11:02 -0800348 # Always make the compilation be debuggable.
349 COMPILE_FLAGS="${COMPILE_FLAGS} --debuggable"
350 fi
351fi
352
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100353if [ "$USE_JVM" = "y" ]; then
Alex Light9c20a142016-08-23 15:05:12 -0700354 export LD_LIBRARY_PATH=${ANDROID_HOST_OUT}/lib64
Mathieu Chartiera61894d2015-04-23 16:32:54 -0700355 # Xmx is necessary since we don't pass down the ART flags to JVM.
Vladimir Markoc5798bf2016-12-09 10:20:54 +0000356 # We pass the classes2 path whether it's used (src-multidex) or not.
357 cmdline="${JAVA} ${DEBUGGER_OPTS} ${JVM_VERIFY_ARG} -Xmx256m -classpath classes:classes2 ${FLAGS} $MAIN $@ ${ARGS}"
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700358 if [ "$DEV_MODE" = "y" ]; then
359 echo $cmdline
360 fi
361 $cmdline
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100362 exit
363fi
364
365
366if [ "$HAVE_IMAGE" = "n" ]; then
Nicolas Geoffray47e61d52017-01-31 09:13:52 +0000367 # Add 5 minutes to give some time to generate the boot image.
368 TIME_OUT_VALUE=$((${TIME_OUT_VALUE} + 300))
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000369 DALVIKVM_BOOT_OPT="-Ximage:/system/non-existant/core.art"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000370else
371 DALVIKVM_BOOT_OPT="-Ximage:${BOOT_IMAGE}"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100372fi
373
374
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100375if [ "$USE_GDB" = "y" ]; then
376 if [ "$HOST" = "n" ]; then
377 GDB="$GDB_SERVER :5039"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100378 else
379 if [ `uname` = "Darwin" ]; then
380 GDB=lldb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700381 GDB_ARGS="$GDB_ARGS -- $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100382 DALVIKVM=
383 else
384 GDB=gdb
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700385 GDB_ARGS="$GDB_ARGS --args $DALVIKVM"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100386 # Enable for Emacs "M-x gdb" support. TODO: allow extra gdb arguments on command line.
387 # gdbargs="--annotate=3 $gdbargs"
388 fi
389 fi
390fi
391
392if [ "$INTERPRETER" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000393 INT_OPTS="-Xint"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700394 if [ "$VERIFY" = "y" ] ; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700395 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=interpret-only"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700396 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700397 elif [ "$VERIFY" = "s" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700398 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-at-runtime"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700399 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-at-runtime"
400 DEX_VERIFY="${DEX_VERIFY} -Xverify:softfail"
401 else # VERIFY = "n"
Richard Uhlerf4b34872016-04-13 11:03:46 -0700402 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-none"
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700403 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
404 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
405 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100406fi
407
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800408if [ "$JIT" = "y" ]; then
Nicolas Geoffraye722d292015-12-15 11:51:37 +0000409 INT_OPTS="-Xusejit:true"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800410 if [ "$VERIFY" = "y" ] ; then
Calin Juravle09665582016-12-20 14:00:48 +0000411 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=interpret-only"
412 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=interpret-only"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800413 else
Richard Uhlerf4b34872016-04-13 11:03:46 -0700414 INT_OPTS="${INT_OPTS} -Xcompiler-option --compiler-filter=verify-none"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800415 COMPILE_FLAGS="${COMPILE_FLAGS} --compiler-filter=verify-none"
416 DEX_VERIFY="${DEX_VERIFY} -Xverify:none"
417 fi
418fi
419
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100420JNI_OPTS="-Xjnigreflimit:512 -Xcheck:jni"
421
422if [ "$RELOCATE" = "y" ]; then
423 COMPILE_FLAGS="${COMPILE_FLAGS} --include-patch-information --runtime-arg -Xnorelocate"
424 FLAGS="${FLAGS} -Xrelocate -Xcompiler-option --include-patch-information"
425 if [ "$HOST" = "y" ]; then
426 # Run test sets a fairly draconian ulimit that we will likely blow right over
427 # since we are relocating. Get the total size of the /system/framework directory
428 # in 512 byte blocks and set it as the ulimit. This should be more than enough
429 # room.
430 if [ ! `uname` = "Darwin" ]; then # TODO: Darwin doesn't support "du -B..."
Alex Lightd26b7e42016-04-08 09:44:54 -0700431 ulimit -S $(du -c -B512 ${ANDROID_HOST_OUT}/framework 2>/dev/null | tail -1 | cut -f1) || exit 1
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100432 fi
433 fi
434else
435 FLAGS="$FLAGS -Xnorelocate"
436 COMPILE_FLAGS="${COMPILE_FLAGS} --runtime-arg -Xnorelocate"
Mathieu Chartiercae2ed92015-06-09 13:02:50 -0700437 if [ "$HOST" = "y" ]; then
438 # Increase ulimit to 64MB in case we are running hprof test.
439 ulimit -S 64000 || exit 1
440 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100441fi
442
443if [ "$HOST" = "n" ]; then
Nicolas Geoffrayd295bc82016-11-04 13:03:05 +0000444 # Need to be root to query /data/dalvik-cache
445 adb root > /dev/null
446 adb wait-for-device
447 ISA=
448 ISA_adb_invocation=
449 ISA_outcome=
450 # We iterate a few times to workaround an adb issue. b/32655576
451 for i in {1..10}; do
452 ISA_adb_invocation=$(adb shell ls -F /data/dalvik-cache)
453 ISA_outcome=$?
454 ISA=$(echo $ISA_adb_invocation | grep -Ewo "${ARCHITECTURES_PATTERN}")
455 if [ x"$ISA" != "x" ]; then
456 break;
457 fi
458 done
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100459 if [ x"$ISA" = "x" ]; then
460 echo "Unable to determine architecture"
Nicolas Geoffray8f500fa2016-11-03 11:18:48 +0000461 # Print a few things for helping diagnosing the problem.
Nicolas Geoffrayd295bc82016-11-04 13:03:05 +0000462 echo "adb invocation output: $ISA_adb_invocation"
463 echo "adb invocation outcome: $ISA_outcome"
Nicolas Geoffray8f500fa2016-11-03 11:18:48 +0000464 echo $(adb shell ls -F /data/dalvik-cache)
465 echo $(adb shell ls /data/dalvik-cache)
466 echo ${ARCHITECTURES_PATTERN}
467 echo $(adb shell ls -F /data/dalvik-cache | grep -Ewo "${ARCHITECTURES_PATTERN}")
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100468 exit 1
469 fi
470fi
471
Wojciech Staszkiewicze6636532016-09-23 10:59:55 -0700472# Prevent test from silently falling back to interpreter in no-prebuild mode. This happens
473# when DEX_LOCATION path is too long, because vdex/odex filename is constructed by taking
474# full path to dex, stripping leading '/', appending '@classes.vdex' and changing every
475# remaining '/' into '@'.
476if [ "$HOST" = "y" ]; then
477 max_filename_size=$(getconf NAME_MAX $DEX_LOCATION)
478else
479 # There is no getconf on device, fallback to standard value. See NAME_MAX in kernel <linux/limits.h>
480 max_filename_size=255
481fi
482# Compute VDEX_NAME.
483DEX_LOCATION_STRIPPED="${DEX_LOCATION#/}"
484VDEX_NAME="${DEX_LOCATION_STRIPPED//\//@}@$TEST_NAME.jar@classes.vdex"
485if [ ${#VDEX_NAME} -gt $max_filename_size ]; then
486 echo "Dex location path too long."
487 exit 1
488fi
489
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100490dex2oat_cmdline="true"
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000491vdex_cmdline="true"
Alex Lightafb5d192016-05-24 15:57:45 -0700492mkdir_locations="${DEX_LOCATION}/dalvik-cache/$ISA"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700493strip_cmdline="true"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100494
Jeff Haodcdc85b2015-12-04 14:06:18 -0800495
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100496if [ "$PREBUILD" = "y" ]; then
Alex Lightafb5d192016-05-24 15:57:45 -0700497 mkdir_locations="${mkdir_locations} ${DEX_LOCATION}/oat/$ISA"
Calin Juravle857f0582016-12-20 14:36:59 +0000498 if [ "$APP_IMAGE" = "y" ]; then
499 # Pick a base that will force the app image to get relocated.
500 app_image="--base=0x4000 --app-image-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.art"
501 fi
502
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000503 dex2oat_cmdline="$INVOKE_WITH $ANDROID_ROOT/bin/dex2oatd \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100504 $COMPILE_FLAGS \
Nicolas Geoffray68e25eb2014-10-29 23:02:11 +0000505 --boot-image=${BOOT_IMAGE} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100506 --dex-file=$DEX_LOCATION/$TEST_NAME.jar \
Andreas Gampe14759242016-03-23 10:54:21 -0700507 --oat-file=$DEX_LOCATION/oat/$ISA/$TEST_NAME.odex \
Jeff Haodcdc85b2015-12-04 14:06:18 -0800508 ${app_image} \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100509 --instruction-set=$ISA"
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700510 if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
511 dex2oat_cmdline="${dex2oat_cmdline} --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
512 fi
Andreas Gampe2ea7b702015-08-07 08:07:16 -0700513
514 # Add in a timeout. This is important for testing the compilation/verification time of
515 # pathological cases.
516 # Note: as we don't know how decent targets are (e.g., emulator), only do this on the host for
517 # now. We should try to improve this.
518 # The current value is rather arbitrary. run-tests should compile quickly.
519 if [ "$HOST" != "n" ]; then
520 # Use SIGRTMIN+2 to try to dump threads.
521 # Use -k 1m to SIGKILL it a minute later if it hasn't ended.
522 dex2oat_cmdline="timeout -k 1m -s SIGRTMIN+2 1m ${dex2oat_cmdline}"
523 fi
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000524 if [ "$TEST_VDEX" = "y" ]; then
Nicolas Geoffray74981052017-01-16 17:54:09 +0000525 vdex_cmdline="${dex2oat_cmdline} ${VDEX_FILTER} --input-vdex=$DEX_LOCATION/oat/$ISA/$TEST_NAME.vdex"
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000526 fi
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700527fi
528
Richard Uhler76f5cb62016-04-04 13:30:16 -0700529if [ "$STRIP_DEX" = "y" ]; then
530 strip_cmdline="zip --quiet --delete $DEX_LOCATION/$TEST_NAME.jar classes.dex"
531fi
532
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700533DALVIKVM_ISA_FEATURES_ARGS=""
534if [ "x$INSTRUCTION_SET_FEATURES" != "x" ] ; then
535 DALVIKVM_ISA_FEATURES_ARGS="-Xcompiler-option --instruction-set-features=${INSTRUCTION_SET_FEATURES}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100536fi
537
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000538# java.io.tmpdir can only be set at launch time.
539TMP_DIR_OPTION=""
540if [ "$HOST" = "n" ]; then
541 TMP_DIR_OPTION="-Djava.io.tmpdir=/data/local/tmp"
542fi
543
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000544# We set DumpNativeStackOnSigQuit to false to avoid stressing libunwind.
545# b/27185632
546# b/24664297
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000547dalvikvm_cmdline="$INVOKE_WITH $GDB $ANDROID_ROOT/bin/$DALVIKVM \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100548 $GDB_ARGS \
549 $FLAGS \
Andreas Gampe2b0fa5b2014-10-31 18:12:30 -0700550 $DEX_VERIFY \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100551 -XXlib:$LIB \
552 $PATCHOAT \
553 $DEX2OAT \
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700554 $DALVIKVM_ISA_FEATURES_ARGS \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100555 $ZYGOTE \
556 $JNI_OPTS \
557 $INT_OPTS \
558 $DEBUGGER_OPTS \
559 $DALVIKVM_BOOT_OPT \
Nicolas Geoffrayc5256042015-12-26 19:41:37 +0000560 $TMP_DIR_OPTION \
Nicolas Geoffraya73280d2016-02-15 13:05:16 +0000561 -XX:DumpNativeStackOnSigQuit:false \
Mathieu Chartier031768a2015-08-27 10:25:02 -0700562 -cp $DEX_LOCATION/$TEST_NAME.jar$SECONDARY_DEX $MAIN $ARGS"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100563
Andreas Gampe3ad5d5e2015-02-03 18:26:55 -0800564# Remove whitespace.
565dex2oat_cmdline=$(echo $dex2oat_cmdline)
566dalvikvm_cmdline=$(echo $dalvikvm_cmdline)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000567vdex_cmdline=$(echo $vdex_cmdline)
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100568
569if [ "$HOST" = "n" ]; then
570 adb root > /dev/null
571 adb wait-for-device
572 if [ "$QUIET" = "n" ]; then
573 adb shell rm -r $DEX_LOCATION
574 adb shell mkdir -p $DEX_LOCATION
575 adb push $TEST_NAME.jar $DEX_LOCATION
576 adb push $TEST_NAME-ex.jar $DEX_LOCATION
577 else
578 adb shell rm -r $DEX_LOCATION >/dev/null 2>&1
579 adb shell mkdir -p $DEX_LOCATION >/dev/null 2>&1
580 adb push $TEST_NAME.jar $DEX_LOCATION >/dev/null 2>&1
581 adb push $TEST_NAME-ex.jar $DEX_LOCATION >/dev/null 2>&1
582 fi
583
Colin Crossafd3c9e2016-09-16 13:47:21 -0700584 LD_LIBRARY_PATH=/data/$TEST_DIRECTORY/art/$ISA
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000585 if [ "$ANDROID_ROOT" != "/system" ]; then
586 # Current default installation is dalvikvm 64bits and dex2oat 32bits,
587 # so we can only use LD_LIBRARY_PATH when testing on a local
588 # installation.
Alex Light7233c7e2016-07-28 10:07:45 -0700589 LD_LIBRARY_PATH=$ANDROID_ROOT/$LIBRARY_DIRECTORY:$LD_LIBRARY_PATH
Nicolas Geoffrayeb441dd2014-10-31 15:34:50 +0000590 fi
591
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700592 PUBLIC_LIBS=libart.so:libartd.so
593
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100594 # Create a script with the command. The command can get longer than the longest
595 # allowed adb command and there is no way to get the exit status from a adb shell
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700596 # command. Dalvik cache is cleaned before running to make subsequent executions
597 # of the script follow the same runtime path.
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100598 cmdline="cd $DEX_LOCATION && \
599 export ANDROID_DATA=$DEX_LOCATION && \
Dimitry Ivanov90d48f22016-05-05 17:24:28 -0700600 export ANDROID_ADDITIONAL_PUBLIC_LIBRARIES=$PUBLIC_LIBS && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100601 export DEX_LOCATION=$DEX_LOCATION && \
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000602 export ANDROID_ROOT=$ANDROID_ROOT && \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700603 rm -rf ${DEX_LOCATION}/dalvik-cache/ && \
Alex Lightafb5d192016-05-24 15:57:45 -0700604 mkdir -p ${mkdir_locations} && \
Sebastien Hertz7cde48c2015-01-20 16:06:43 +0100605 export LD_LIBRARY_PATH=$LD_LIBRARY_PATH && \
Nicolas Geoffray4f7fdd22015-04-24 11:57:37 +0100606 export PATH=$ANDROID_ROOT/bin:$PATH && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100607 $dex2oat_cmdline && \
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000608 $vdex_cmdline && \
Richard Uhler76f5cb62016-04-04 13:30:16 -0700609 $strip_cmdline && \
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100610 $dalvikvm_cmdline"
611
612 cmdfile=$(tempfile -p "cmd-" -s "-$TEST_NAME")
613 echo "$cmdline" > $cmdfile
614
615 if [ "$DEV_MODE" = "y" ]; then
616 echo $cmdline
617 fi
618
619 if [ "$QUIET" = "n" ]; then
620 adb push $cmdfile $DEX_LOCATION/cmdline.sh
621 else
622 adb push $cmdfile $DEX_LOCATION/cmdline.sh > /dev/null 2>&1
623 fi
624
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700625 if [ "$DRY_RUN" != "y" ]; then
626 adb shell sh $DEX_LOCATION/cmdline.sh
627 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100628
629 rm -f $cmdfile
630else
631 export ANDROID_PRINTF_LOG=brief
Andreas Gampea8780822015-03-13 19:51:09 -0700632
633 # By default, and for prebuild dex2oat, we are interested in errors being logged. In dev mode
634 # we want debug messages.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700635 if [ "$EXTERNAL_LOG_TAGS" = "n" ]; then
636 if [ "$DEV_MODE" = "y" ]; then
637 export ANDROID_LOG_TAGS='*:d'
638 else
639 export ANDROID_LOG_TAGS='*:e'
640 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100641 fi
Andreas Gampea8780822015-03-13 19:51:09 -0700642
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100643 export ANDROID_DATA="$DEX_LOCATION"
Nicolas Geoffray8eedb472014-10-29 14:05:59 +0000644 export ANDROID_ROOT="${ANDROID_ROOT}"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700645 export LD_LIBRARY_PATH="${ANDROID_ROOT}/${LIBRARY_DIRECTORY}:${ANDROID_ROOT}/${TEST_DIRECTORY}"
646 export DYLD_LIBRARY_PATH="${ANDROID_ROOT}/${LIBRARY_DIRECTORY}:${ANDROID_ROOT}/${TEST_DIRECTORY}"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100647 export PATH="$PATH:${ANDROID_ROOT}/bin"
648
David Srbeckyc9ede382015-06-20 06:03:53 +0100649 # Temporarily disable address space layout randomization (ASLR).
650 # This is needed on the host so that the linker loads core.oat at the necessary address.
651 export LD_USE_LOAD_BIAS=1
652
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100653 cmdline="$dalvikvm_cmdline"
654
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700655 if [ "$TIME_OUT" = "gdb" ]; then
656 if [ `uname` = "Darwin" ]; then
657 # Fall back to timeout on Mac.
658 TIME_OUT="timeout"
Hiroshi Yamauchic823eff2015-09-01 16:21:35 -0700659 elif [ "$ISA" = "x86" ]; then
660 # prctl call may fail in 32-bit on an older (3.2) 64-bit Linux kernel. Fall back to timeout.
661 TIME_OUT="timeout"
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700662 else
663 # Check if gdb is available.
664 gdb --eval-command="quit" > /dev/null 2>&1
665 if [ $? != 0 ]; then
666 # gdb isn't available. Fall back to timeout.
667 TIME_OUT="timeout"
668 fi
669 fi
670 fi
671
672 if [ "$TIME_OUT" = "timeout" ]; then
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100673 # Add timeout command if time out is desired.
Andreas Gampe038bb222015-01-13 19:48:14 -0800674 #
Andreas Gampe6fb92562016-08-01 21:53:57 -0700675 # Note: We first send SIGRTMIN+2 (usually 36) to ART, which will induce a full thread dump
676 # before abort. However, dumping threads might deadlock, so we also use the "-k"
677 # option to definitely kill the child.
678 cmdline="timeout -k 120s -s SIGRTMIN+2 ${TIME_OUT_VALUE}s $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100679 fi
680
681 if [ "$DEV_MODE" = "y" ]; then
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000682 echo "mkdir -p ${mkdir_locations} && $dex2oat_cmdline && $vdex_cmdline && $strip_cmdline && $cmdline"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100683 fi
684
685 cd $ANDROID_BUILD_TOP
686
David Srbecky2e4afe82016-01-27 18:42:06 +0000687 rm -rf ${DEX_LOCATION}/dalvik-cache/
Alex Lightafb5d192016-05-24 15:57:45 -0700688 mkdir -p ${mkdir_locations} || exit 1
Andreas Gampea8780822015-03-13 19:51:09 -0700689 $dex2oat_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000690 $vdex_cmdline || { echo "Dex2oat failed." >&2 ; exit 2; }
Richard Uhler76f5cb62016-04-04 13:30:16 -0700691 $strip_cmdline || { echo "Strip failed." >&2 ; exit 3; }
Andreas Gampea8780822015-03-13 19:51:09 -0700692
693 # For running, we must turn off logging when dex2oat or patchoat are missing. Otherwise we use
694 # the same defaults as for prebuilt: everything when --dev, otherwise errors and above only.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700695 if [ "$EXTERNAL_LOG_TAGS" = "n" ]; then
696 if [ "$DEV_MODE" = "y" ]; then
697 export ANDROID_LOG_TAGS='*:d'
698 elif [ "$USE_DEX2OAT_AND_PATCHOAT" = "n" ]; then
699 # All tests would log the error of failing dex2oat/patchoat. Be silent here and only
700 # log fatal events.
701 export ANDROID_LOG_TAGS='*:s'
702 else
703 # We are interested in LOG(ERROR) output.
704 export ANDROID_LOG_TAGS='*:e'
705 fi
706 fi
707
708 if [ "$DRY_RUN" = "y" ]; then
709 exit 0
Andreas Gampea8780822015-03-13 19:51:09 -0700710 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100711
712 if [ "$USE_GDB" = "y" ]; then
713 # When running under gdb, we cannot do piping and grepping...
Dmitriy Ivanovf57874d2014-10-07 13:43:23 -0700714 $cmdline "$@"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100715 else
Hiroshi Yamauchi6ffb9cc2015-08-31 15:14:17 -0700716 if [ "$TIME_OUT" != "gdb" ]; then
717 trap 'kill -INT -$pid' INT
718 $cmdline "$@" 2>&1 & pid=$!
719 wait $pid
720 # Add extra detail if time out is enabled.
721 if [ ${PIPESTATUS[0]} = 124 ] && [ "$TIME_OUT" = "timeout" ]; then
722 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
723 fi
724 else
725 # With a thread dump that uses gdb if a timeout.
726 trap 'kill -INT -$pid' INT
727 $cmdline "$@" 2>&1 & pid=$!
728 # Spawn a watcher process.
729 ( sleep $TIME_OUT_VALUE && \
730 echo "##### Thread dump using gdb on test timeout" && \
731 ( gdb -q -p $pid --eval-command="info thread" --eval-command="thread apply all bt" \
732 --eval-command="call exit(124)" --eval-command=quit || \
733 kill $pid )) 2> /dev/null & watcher=$!
734 wait $pid
735 test_exit_status=$?
736 pkill -P $watcher 2> /dev/null # kill the sleep which will in turn end the watcher as well
737 if [ $test_exit_status = 0 ]; then
738 # The test finished normally.
739 exit 0
740 else
741 # The test failed or timed out.
742 if [ $test_exit_status = 124 ]; then
743 # The test timed out.
744 echo -e "\e[91mTEST TIMED OUT!\e[0m" >&2
745 fi
746 fi
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100747 fi
748 fi
749fi